<?php

require_once("OAuth.php");

function ning_pub_get_access_token($network_url, $consumer_key, $consumer_secret, $email, $password) {
    $hmac_method = new OAuthSignatureMethod_HMAC_SHA1();
    $plaintext_method = new OAuthSignatureMethod_PLAINTEXT();
    $sig_method = $plaintext_method;

    $endpoint = sprintf("https://external.ningapis.com/xn/rest/%s/1.0/Token", $network_url);

    $oauth_consumer = new OAuthConsumer($consumer_key, $consumer_secret);

    $oauth_req = OAuthRequest::from_consumer_and_token($oauth_consumer, NULL, "GET", $endpoint);
    $oauth_req->sign_request($sig_method, $oauth_consumer, NULL);

    $post_fields = $oauth_req->get_parameters();
    $post_fields_encoded = http_build_query($post_fields);

    $ch = curl_init();

    curl_setopt($ch, CURLOPT_URL, $endpoint);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);

    // http://curl.haxx.se/docs/faq.html#Why_do_I_get_certificate_verify
    // http://dev.soup.io/post/56438473/If-youre-using-MAMP-and-doing-something
    // curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);

    curl_setopt($ch, CURLOPT_POSTFIELDS, $post_fields_encoded);
    curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
    curl_setopt($ch, CURLOPT_USERPWD, $email . ":" . $password);

    $result = curl_exec($ch);
    if (!$result) {
        print "<p>curl error: " . curl_error($ch) . "</p>\n";
        return NULL;
    } else {
        $payload = json_decode($result);
        if ($payload->success) {
            return $payload->entry;
        } else {
            print "<p>Error: <b>$payload->reason</b></p>";
            return NULL;
        }
    }
}

function add_value($name) {
    if (isset($_REQUEST[$name])) {
        print ' value="' . $_REQUEST[$name] . '" ';
    }
}
?>
<html>
    <head>
        <title>Ning Publisher - Generate Access Token</title>
    </head>
    <body>
        <h1>Ning Publisher - Generate Access Token</h1>
        <form method="POST">
            <fieldset>
                <legend>Network Information</legend>
                <ol>
                    <li>
                        <label for="subdomain">Subdomain</label>
                        <input id="subdomain" name="subdomain" type="text"<?php add_value("subdomain") ?> />
                    </li>
                    <li>
                        <label for="consumer_key">Consumer Key</label>
                        <input id="consumer_key" name="consumer_key" type="text" size="40" <?php add_value("consumer_key") ?> />
                    </li>
                    <li>
                        <label for="consumer_secret">Consumer Secret</label>
                        <input id="consumer_secret" name="consumer_secret" type="text" size="40"<?php add_value("consumer_secret") ?> />
                    </li>
                </ol>
            </fieldset>

            <fieldset>
                <legend>Member Information</legend>
                <ol>
                    <li>
                        <label for="email">Member Email</label>
                        <input id="email" name="email" type="text"<?php add_value("email") ?> />
                    </li>
                    <li>
                        <label for="password">Member Password</label>
                        <input id="password" name="password" type="password" />
                    </li>
                </ol>
            </fieldset>
            <p>
                <input type="submit" value="Generate Token" />
            </p>
        </form>
<?php
    if( isset($_REQUEST["subdomain"]) &&
        isset($_REQUEST["consumer_key"]) &&
        isset($_REQUEST["consumer_secret"]) &&
        isset($_POST["email"]) &&
        isset($_POST["password"]
        )) {
        $network_url = $_REQUEST["subdomain"];
        $consumer_key = $_REQUEST["consumer_key"];
        $consumer_secret = $_REQUEST["consumer_secret"];
        $email = $_POST["email"];
        $password = $_POST["password"];

        $response = ning_pub_get_access_token($network_url, $consumer_key, $consumer_secret, $email, $password);
        if ($response) {
?>
<dl>
    <dt>Member Email:</dt>
        <dd><?php print $_POST["email"] ?></dd>
    <dt>Access Token:</dt>
        <dd><?php print $response->oauthToken ?></dd>
    <dt>Access Token Secret:</dt>
        <dd><?php print $response->oauthTokenSecret ?></dd>
</dl>
<?php
        }
    }
?>
    </body>
</html>
